package com.jiuqi.util.tree;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

public abstract class FastTreeBuilder implements TreeBuilder {
   protected ObjectVistor visitor;

   public FastTreeBuilder(ObjectVistor visitor) {
      this.visitor = visitor;
   }

   public TreeNode build(Iterator iterator) {
      List allNodes = new ArrayList();
      HashMap nodeFinder = new HashMap();

      while(iterator.hasNext()) {
         Object item = iterator.next();
         TreeNode node = new TreeNode(item);
         allNodes.add(node);
         nodeFinder.put(this.getObjectCode(item), node);
      }

      TreeNode root = new TreeNode();
      HashSet paths = new HashSet();

      for(int i = 0; i < allNodes.size(); ++i) {
         TreeNode node = (TreeNode)allNodes.get(i);
         if (node.getParent() == null) {
            paths.clear();

            while(true) {
               paths.add(this.getObjectCode(node.getItem()));
               TreeNode parent = (TreeNode)nodeFinder.get(this.getObjectParent(node.getItem()));
               if (parent == null || paths.contains(this.getObjectCode(parent.getItem()))) {
                  node = (TreeNode)allNodes.get(i);
                  if (node.getParent() == null) {
                     node.setParent(root);
                  }
                  break;
               }

               node.setParent(parent);
               node = parent;
            }
         }
      }

      return root;
   }

   protected abstract String getObjectCode(Object var1);

   protected abstract String getObjectParent(Object var1);
}
